/*
======================================================
rslib component: ConfigFile  prototypes/implimentors
======================================================
*/


namespace rslib
{
	ConfigFile::~ConfigFile()
	{
	}


	ConfigFile::ConfigFile(string pfilename,int psize)
	{
	unitseperator=char(31);
	recordseperator=char(30);
	filename=pfilename;

	if(psize<2)psize=1;

	size=psize;

	settings = new SettingEntry[size];
	}


	void ConfigFile::SetSeperator(char us,char rs)
	{
	unitseperator=us;
	recordseperator=rs;
	}


	bool ConfigFile::Load()
	{
		fstream fin(filename.c_str(),ios::in);

		if(!fin)return false;

		char data;

		int pos=0,entry=0;
		int status=0;
		string buffer;


		while(!fin.eof())
		{
			data=fin.get();
		
			if(status==0 && data==unitseperator)
			{
				status=1;
				
				settings[entry].field=buffer;
				
				buffer="";
				pos=0;
				continue;
			}
			else if(status==1 && data==recordseperator)
			{
				status=0;
				
				settings[entry].value=buffer;		
				
				entry++;
				if(entry>=size)GrowArray();
				buffer="";
				pos=0;			
				continue;
			}
		

			buffer.append(1,data);
			pos++;
		}

		return true;
	}


	bool ConfigFile::Save()
	{
	fstream fout(filename.c_str(),ios::out);

	if(!fout)return false;


	    //loop through items and output to file
	    for(int i=0;i<size;i++)
	    {
		if(settings[i].field.size()<1)continue;
	    fout<<settings[i].field<<unitseperator;
	    fout<<settings[i].value<<recordseperator;
	    }

	fout.close();

	return true;
	}



	string ConfigFile::GetSetting(string field)
	{
	for(int i=0;i<size;i++)if(settings[i].field==field)return settings[i].value;

	return "";
	}
	
	string ConfigFile::GetFileName()
	{
		return filename;
	}

	bool ConfigFile::SetValue(string field,string value)
	{
		return SetSetting(field,value);
	}

	
	bool ConfigFile::SetSetting(string field,string value)
	{
		//if field exists we edit it
		for(int i=0;i<size;i++)
		if(settings[i].field==field)
		{
		settings[i].value=value;
		return true;
		}
		
		//if not we try to find an empty field and use it
		
		for(int i=0;i<size;i++)
		if(settings[i].field=="")
		{
		settings[i].field=field;
		settings[i].value=value;
		return false;
		}
		
		//now we have to increase size of array to add it in
		int oldsize=size;
		GrowArray();
		settings[oldsize].field=field;
		settings[oldsize].value=field;
		
	return false;
	}

	bool ConfigFile::DeleteSetting(string field)
	{

		for(int i=0;i<size;i++)
		if(settings[i].field==field)
		{
		settings[i].field="";
		return true;
		}

	return false;
	}

	
	//makes array bigger if required
	void ConfigFile::GrowArray()
	{
	int newsize = size+2+size/10;

	SettingEntry * tempsettings = new SettingEntry[newsize];


		for(int i=0;i<size;i++)
		tempsettings[i]=settings[i];	
		
		settings=tempsettings;
		
	size=newsize;
	}



	void ConfigFile::ListSettings()
	{
	cout<<"\n"<<ForceSize("---------------- Settings Listing ",50,'-')<<"\n\n";

	int entries=0;
		for(int i=0;i<size;i++)
		{
		if(settings[i].field.size()<1)continue;
		cout<<ForceSize(settings[i].field,40,'.')<<" "<<settings[i].value<<"\n";
		entries++;
		}
		
	cout<<"\n--------------------------------------------------";
	cout<<"\nEntries: "<<ForceSize(Int2Str(entries),26)<<"Array size: "<<ForceSize(Int2Str(size),10)<<"\n";
	}


}

