/*
======================================================
rslib component: Containers implimentors
======================================================
*/




namespace rslib
{
		template <class T>
		void xVector<T>::InternalLock()
		{
			if(!ThreadSafe)return;
			#ifdef rslib_pthread
				internalmutex.Lock();
			#endif				
		}
		
		template <class T>
		void xVector<T>::InternalUnlock()
		{
			if(!ThreadSafe)return;
			#ifdef rslib_pthread
				internalmutex.UnLock();
			#endif
		}
		
	
		template <class T>
		xVector<T>::xVector()
		{
			
			#ifdef rslib_pthread	
				ThreadSafe=true;				
			#else
				ThreadSafe=false;
			#endif
		}

		template <class T>
		xVector<T>::~xVector()
		{
		}
		
		template <class T> 
		void xVector<T>::Lock()
		{
			if(!ThreadSafe)return;		
			#ifdef rslib_pthread	
				externalmutex.Lock();				
			#endif
		}
		
		template <class T> 
		bool xVector<T>::TryLock()
		{
			if(!ThreadSafe)return true;
				
			#ifdef rslib_pthread	
				return externalmutex.TryLock();				
			#endif
			return true;
		}		
		
		template <class T> 
		void xVector<T>::Unlock()
		{
			if(!ThreadSafe)return;
			#ifdef rslib_pthread
				externalmutex.UnLock();
			#endif
		}
		
		template <class T> 
		bool xVector<T>::IsEmpty()
		{
			this->InternalLock();
			int ret = DATA.empty();
			this->InternalUnlock();
			return ret;
		}
		
		template <class T> 
		unsigned long int xVector<T>::GetSize()
		{
			this->InternalLock();
			int ret= DATA.size();
			this->InternalUnlock();		
			return ret;
		}
		
		template <class T> 
		unsigned long int xVector<T>::GetMaxsize()
		{
			this->InternalLock();
			int ret=DATA.max_size();
			this->InternalUnlock();	
			return ret;
		}
		
		template <class T> 
		bool xVector<T>::Erase(T item)
		{
			bool ret=false;
			this->InternalLock();
			
			for(int i=0;i<DATA.size();i++)
			{
				if(item==DATA[i])ret=EraseAt(i,true);
			}
			this->InternalUnlock();		
			return ret;
		}
		
		template <class T> 
		bool xVector<T>::EraseAt(int pos,bool unsafe)
		{
			bool ret=true;
			if(!unsafe)this->InternalLock();
			if(pos>=0 && pos<DATA.size()) DATA.erase(DATA.begin()+pos);
			else ret=false;
			if(!unsafe)this->InternalUnlock();	
			return ret;			
		}
		
		template <class T> 
		bool xVector<T>::EraseAt(int pos)
		{
			return this->EraseAt(pos,false);
		}
		
		
		template <class T> 
		bool xVector<T>::PopFrom(T & togive,int pos)
		{
			if(DATA.size()<=0)return false;
			this->InternalLock();
			
			bool ret=true;
			if(pos>=0 && pos<DATA.size())
			{
				togive=DATA[pos];
				DATA.erase(DATA.begin()+pos);
			}
			else ret=false;			

			this->InternalUnlock();	

			return ret;
		}
		
		template <class T>
		bool xVector<T>::Get(T & give,int pos)
		{			
			this->InternalLock();
			bool ret=true;
			if(pos>=0 && pos<DATA.size()) give=DATA[pos];
			else ret=false;
						
			this->InternalUnlock();	
			
			return ret;
		}
		
		template <class T>
		bool xVector<T>::Find(T tofind)
		{
			for(int i=0;i<GetSize();i++)
			{
				if(tofind==DATA[i])return true;
			}
			return false;
		}
		
		template <class T>
		void xVector<T>::Add(T item,int pos)
		{
			this->InternalLock();
			if(pos<0 || pos>DATA.size())pos=DATA.size();
			DATA.insert(DATA.begin()+pos,item);
			this->InternalUnlock();		
		}
		
		template <class T>
		void xVector<T>::Add(T item)	
		{
			this->Add(item,-1);
		}		
		
		template <class T> 
		void xVector<T>::Clear()
		{
			this->InternalLock();
			DATA.clear();
			this->InternalUnlock();		
		}
		
		template <class T> 
		xVector<T> & xVector<T>::operator+=(const T tw)
		{
			Add(tw);
			
			return *this;
		}
}










