namespace rslib
{


#ifndef MysqlCon_h
#define MysqlCon_h



class MysqlCon
{
	private:
		mysqlpp::Connection * CON;
		uli m_MySqlAffectedRows;
		static uli m_connectionid;
		mysqlpp::UseQueryResult m_res;
		string m_connectionid_str;
		string m_host;
		string m_user;
		string m_pass;		
		string m_error;
		
	public:
		MysqlCon(string host,string user,string pass);
		void SetName(string name);
		void Debug(int level,string str);
		bool Connect(string host,string user, string pass); //connects to db, returns false on failure
		bool Connect(); //uses default settings to connect
		bool DoQuery(string querystr); //does query
		mysqlpp::UseQueryResult GetResult(); //gets query result
		bool SelectDB(string db); //selects db, returns false on failure
		bool CreateDB(string db); //creates db
		uli AffectedRows(); //returns affected rows from last query
		void Disconnect(); //disconnects
		string GetError(bool clear); //gets error string if there was an error (and clears it if param is true)
		bool IsConnected(); //whether or not we are connected
		
		bool debug; //toggle debug mode
		
};










}

#endif

