/*
======================================================
rslib component:  prototypes/implimentors
======================================================
*/


namespace rslib
{

	MUTEX::MUTEX()
	{
		#ifdef WIN32
			mutex=true;
		#elif linux
			pthread_mutex_init (&mutex, NULL);
		#endif
	}
	
	MUTEX::~MUTEX()
	{
		#ifdef linux
			pthread_mutex_destroy(&mutex);
		#endif	
	}
	
	void MUTEX::Lock(int delaybetweenlocks)
	{
		#ifdef WIN32
			while(!mutex)Wait(delaybetweenlocks);
			mutex=false;
		#elif linux
			while(pthread_mutex_lock( &mutex )!=0)Wait(delaybetweenlocks);
		#endif	
	}
	
	
	bool MUTEX::TryLock()
	{
		#ifdef WIN32
			if(mutex)
			{
				mutex=false;
				return true;
			}
			return false;
		#elif linux
			return(pthread_mutex_trylock( &mutex )==0);
		#endif	
		return false;
	}
	
	void MUTEX::UnLock()
	{
		#ifdef WIN32
			mutex=true;
		#elif linux
			pthread_mutex_unlock( &mutex );
		#endif	
	}

}
