/*
======================================================
rslib component: smart pointers implimentors
======================================================
*/


namespace rslib
{
	//--------------------   User editable vars:   ---------------------
	
	template <typename T> bool SP<T>::DebugAlloc=true;   //set to true to enable debugging
	
	//-----------------   End user editable vars   ---------------------

	
	template <typename T> SP<T>::SP(T * newobject)
	{	
		DATA = new SPobject;
		DATA->object = newobject;
		DATA->refcount=1;
		
		CheckCount(true);
	}


	template <typename T> SP<T>::~SP()
	{
		CheckCount(false);
	}

	template <typename T> bool SP<T>::CheckCount(bool incr)
	{
		if(incr)
		{
			DATA->refcount++;
			if(DebugAlloc)
			{
				cout<<"SmtPtr Debug:"<<DATA<<" refcount increased = "<<DATA->refcount<<endl;
			}
			return true;
		}
		
		DATA->refcount--;
		
		if(DebugAlloc)
		{
			cout<<"SmtPtr Debug:"<<DATA<<" refcount decreased = "<<DATA->refcount<<endl;
		}		
		
		if(DATA->refcount<=0) // free memory
		{		
			if(DebugAlloc)
			{
				cout<<"SmtPtr Debug:"<<DATA<<" Freeing memory. refcount = "<<DATA->refcount<<endl;
			}
			delete DATA->object;
			delete DATA;
			DATA=NULL;
			return false;
		}
			
		return true;
	}
	
	
	
    template <typename T> SP<T>& SP<T>::operator=(const SP<T>& tw)
    {
    	if (this == &DATA || tw.DATA) return *this;    //make sure we're not assigning ourselves to ourselves
		
		DATA=tw.DATA;
		
		CheckCount(true);
		
    	return *this;
    }	

	
	template <typename T> SP<T>::SP(const SP<T> & sc)
	{
		DATA=sc.DATA;	
	}
	
	template <typename T> bool SP<T>::operator==(const SP<T> & comp)
	{
		return(DATA==comp.DATA);
	}

	
	template <typename T> T* SP<T>::Access()
	{
		if(DATA!=NULL && DATA->object!=NULL) return DATA->object;
		return NULL;
	}



}