/*
======================================================
rslib component:  parsing and str manipulator implimentors
======================================================
*/


namespace rslib
{

	Parser::Parser(string WorkString="")
	{
		m_WorkString=WorkString;
	}
	
	string Parser::Delete(string workstr,string todel,int startpos=0,int endpos=-1)
	{
		if(startpos<0)startpos=0;
		else if(startpos>workstr.size()+todel.size() || todel.size()<=0)return workstr;
		
		if(endpos<0)endpos=workstr.size()-1;
		
		while(1)
		{		
			int pos=workstr.find(todel,startpos);
			if(pos==string::npos || pos>endpos)break;
			
			workstr.erase(pos,todel.size());
			endpos-=todel.size();			
			
		}
		
		return workstr;
	} 
	
	string Parser::DeleteOne(string workstr,string todel,int startpos=0,int endpos=-1)
	{
		if(startpos<0)startpos=0;
		else if(startpos>workstr.size()+todel.size() || todel.size()<=0)return workstr;
		
		if(endpos<0)endpos=workstr.size()-1;
		
		int pos=workstr.find(todel,startpos);
		if(pos==string::npos || pos>endpos)return workstr;
		
		workstr.erase(pos,todel.size());
		
		return workstr;
	}

	xVector<string> Parser::Explode(string workstr,string delim)
	{
		xVector<string> ret;
		int pos;
		

		while(1)
		{
			pos=workstr.find(delim);
			if(pos==string::npos)break;
			ret.Add(workstr.substr(0,pos));
			workstr.erase(0,pos+delim.size());	
		}
		ret.Add(workstr);
	
		return ret;
	}
	
	xVector<string> Parser::Explode(xVector<string> workstr,string delim)
	{
		xVector<string> ret;
		xVector<string> tmpvect;
		
		
		string tmpstr,tmpstr2;
		for(int i=0;workstr.Get(tmpstr,i);i++)
		{
			tmpvect = Explode(tmpstr,delim);
			
			for(int ii=0;tmpvect.Get(tmpstr2,ii);ii++)ret.Add(tmpstr2);			
		}
		return ret;
	}
	
	xVector<string> Parser::FilterIn(xVector<string> data,string start,string end,bool truncate)
	{
		xVector<string> ret;
		
		string tmp;
		bool markasgood;
		
		for(int i=0;data.Get(tmp,i);i++)
		{
			markasgood=false;
			
			if((start.size()<=0 || tmp.find(start,0)==0) && (end.size()<=0 || tmp.find(end,tmp.size()-end.size())!=string::npos))
			{
				markasgood=true;
				
				if(truncate)
				{
					tmp = DeleteOne(tmp,start,0,1);
					tmp = DeleteOne(tmp,end,tmp.size()-end.size(),tmp.size());			
				}			
			}
			
			if(markasgood)ret.Add(tmp);		
		}
		return ret;
	}




	string Uint2StrHex(unsigned long int sourceint)
	{
		stringstream ss;

		ss <<"0x"<<hex<<sourceint;

		string val;
		ss >> val;
		return val;	
	}
	
	string Int2StrHex(long int sourceint)
	{
		stringstream ss;

		ss <<"0x"<<hex<<sourceint;

		string val;
		ss >> val;
		return val;	
	}	


	//turns long int to string
	string Int2Str(long int sourceint)
	{
		stringstream ss;

		ss << sourceint;

		string val;
		ss >> val;
		return val;
	}	
	
	//turns unsigned long int to string
	string Uint2Str(unsigned long int sourceint)
	{
		stringstream ss;

		ss << sourceint;

		string val;
		ss >> val;
		return val;
	}	


	//turns string to int
	int Str2Int(string sourcestr)
	{
		return atoi(sourcestr.c_str());
	}

	//turns str to bool
	bool Str2Bool(string source)
	{
		if(source.size()<1)return false;
		if(tolower(source[0])=='y' || tolower(source[0])=='t' || tolower(source[0])=='1')return true;
		return false;
	}

	

	string str_replace(string torep,string tostr,string org)
	{
		string newstring=org;
		int pos=0;
		int chunksize=torep.size();
				
		while(1)
		{
			pos=newstring.find(torep);				
			if(pos==string::npos)break;
			
			newstring.erase(pos,chunksize);
			newstring.insert(pos,tostr);		
		}
		
		return newstring;
	}



}






