/*
======================================================
rslib component:  parsing and str manipulator prototypes
======================================================
*/

#ifndef strmanip_h
#define strmanip_h

namespace rslib
{
	class Parser
	{
		private:
			string m_WorkString;
		
		public:
			Parser(string workstr);
			static string Delete(string workstr,string todel,int startpos,int endpos);		//deletes all instances of todel between startpos and endpos
			static string DeleteOne(string workstr,string todel,int startpos,int endpos);	//deletes first instance of todel within given range
			static xVector<string> Explode(string workstr,string delim);					//explodes all contents between delim
			static xVector<string> Explode(xVector<string> workstr,string delim);			//explodes all contents between delim within each element of the array
			static xVector<string> FilterIn(xVector<string> data,string start,string end,bool truncate); //filters array of strings that match start/end and returns array with just those.  Set bool to true to also truncate the matched parts.
	
	};

	
	
	
	
	
	
	
	
	
	
	
	//misc str manip functions:


	string Uint2StrHex(unsigned long int sourceint);	//turns uint to a hex string
	string Int2StrHex(long int sourceint); //turns int to a HEX string
	
	string Int2Str(long int sourceint);		//turns long int to string 
	
	string Uint2Str(unsigned long int sourceint); //turns unsigned long int to string

	
	int Str2Int(string sourcestr); //turns string to int
	
	bool Str2Bool(string source); //turns str to bool

	string str_replace(string torep,string tostr,string org); //replaces all occurences of torep with tostr in org, and returns it


}


#endif
