/*
======================================================
rslib component:  prototypes
======================================================
*/

#ifndef userio_h
#define userio_h

namespace rslib
{

    void Wait(int);     //sleep (specified in ms):      
    void ClearScreen();  //clear screen
    void PressReturn(string);  //say something and wait for user to hit enter
	unsigned int GetChar();    //get 1 char
	void Pause();              //pause with no text
    
    
	string PromptPassword(string prompt,string def, int max);	//prompt for a password
    string PromptString(string prompt,string def,int max,bool password);	//prompts user for string

    long int PromptInt(string,string); 	//prompts for an int
    long int PromptInt(string);			//prompts for an int
    
    bool PromptBool(string string);		//prompts for a bool
	
	string WrapText(string text,int indent,int width);	//displays text but auto wraps words to fit in specific area
    
	string ForceSize(string str,int size,char fillerchar);    //creates a string but adds filler chars
    
	
	
	//stuff for ValidateString:
	
	//ex usage:
	//ValidateString(string,FLAG1 | FLAG2 | FLAG3,false);
	
	
	#define VALFLG_NOCAPS 1				//No capital letters
	#define VALFLG_NONUM 2				//No numbers
	#define VALFLG_NOSPACE 4			//no space
	#define VALFLG_SQL	8				//SQL (escape quotes and stuff)  (used more for escaping then validating)
	#define VALFLG_FILENAME 16			//Chars ok for file names
	#define VALFLG_FILEPATH 32			//chars ok for file path (same as file name but \ and / are allowed)
	#define VALFLG_SPECIALCHARS 64 		//special ascii chars (quotes and stuff are ok)
	#define VALFLG_STRICTUSERNAME 128	//Must be alpha numeric and only allows a few special chars like _ and -
	#define VALFLG_NOEMTPY 256			//validates that the string has data in it
	
	bool ValidateString(string & tovalidate,unsigned long int flags,bool changetovalidate);	//validates text based on passed flags
	bool ValidateNumber(int & tovalidate,long int min,long int max,bool changetovalidate); //validate number to be in specific range

	string FixSQL(string tofix);		//fixes stuff so it can be used safely in sql





}


#endif

