/**********************************************************
EnviroState C++ header file
Environmental Monitoring System
Last modified by Red Squirrel on Oct-08-2012 11:41:42pm
Filepath: includes/Agent.h
Lines of code: 31

Description: Agent entry (server mode)

***********************************************************/


#ifndef Agent_h
#define Agent_h

class Agent
{
	friend class ServerCore;
	friend class AgentNetSession;
	friend class Monitor;
	
	private:
		ServerCore * m_core;			//the core (declared in program main() function)
		string m_name;			//agent name
		MlConfFile * m_config;	//config (declared in core)		
		DateTime m_lastupdate;	//last time it was updated from the remote agent		

		bool DoDump2Disk;		//set to true to make this agent dump it's data to disk next time it polls
		
		
		//------- config settings ---------
		//---------------------------------
		
		string m_originip;
		int m_pollinterval;
		int m_failheartbeat;	
		bool m_sentheartbeatalert;
		
		xVector<string> m_alert_emails;
		
		xVector<Monitor*> m_monitors;	//monitors for this agent  
		
		//------- end config settings ------
		//----------------------------------
		
		
		
	
	public:
		Agent(ServerCore * core,string name);
		void Log(int value,string text);			//debug entry
		~Agent();
		bool Load(); 								//loads monitors
		bool Poll();								//polls monitors
		bool Dump2Disk();							//dumps data to disk
		Monitor * GetMonitor(string name);			//gets monitor by name, returns null of it does not exist
		void HeartBeat();							//called when the agent connects
		void FireAlarm(bool recover=false);			//fires alarm if heartbeat has not been received
	
};


#endif