/**********************************************************
EnviroState C++ header file
Environmental Monitoring System
Last modified by Red Squirrel on Sep-28-2012 09:35:22pm
Filepath: includes/network/AgentNetSession.h
Lines of code: 29

Description: Network session handler for a single agent client session (server mode)

***********************************************************/


#ifndef agentsession_h
#define agentsession_h

class Server;
class ServerCore;
class Agent;
class Monitor;

class AgentNetSession
{
	private:
		ServerCore * m_core;		
		ServerClient m_client;
		Agent * m_agentobject;			//agent (once determined)
		Monitor * m_monitor;			//monitor being worked on
		xVector<Monitor*> m_agentmonitors;	//temp store for monitors for when they are being sent to client (one popped per cycle)

		int m_handlernum;		
		int m_subhandlernum;
		string m_buffer;		
		string PopBufferStr();	//returns one string and removes it from buffer
		
		string m_tempstr1;
		string m_tempstr2;
		string m_tempstr3;
		
	public:
		AgentNetSession(ServerCore * core, ServerClient m_client);		
		~AgentNetSession();
		void Log(int val,string text);	//debug
		
		bool Poll();				//processes tcp connection
		bool Disconnected();		//returns true if client is disconnected
};


#endif

-D__USE_MALLOC