/**********************************************************
EnviroState C++ header file
Environmental Monitoring System
Last modified by Red Squirrel on Aug-20-2012 04:38:29am
Filepath: includes/MlConfFile/MlConfBlock.h
Lines of code: 28

Description: 

***********************************************************/


#ifndef MlConfBlock_h
#define MlConfBlock_h

class MlConfFile;
class MlConfVar;

class MlConfBlock
{
	friend class MlConfFile;
  private:
    string m_name;
	MlConfFile * m_mlconffile;
    MlConfBlock * m_parent;
    xVector<MlConfBlock*> m_blocks;	
    xVector<MlConfVar*> m_vars;
    
    bool Load(fstream & fd,string filepath);//loads block using file descriptor
	void Log(int level,string str);
	
	MlConfVar * GetValue(string var);  		//get a conf var  
	MlConfBlock * GetBlock(string path);	//get block at given path
	
	string DumpData(string base);			//dumps all data into a string for displaying	(used internally, base path is passed through)
  
  public:
    MlConfBlock(MlConfFile * file,MlConfBlock * parent,string name);
    ~MlConfBlock();
	string Name();
    
  
    void SetValue(MlConfVar * var);		//set a conf var
	
	void AddConfBlock(MlConfBlock * block);	//add conf block
	
	
	string DumpData();								//dumps all data into a string for displaying
    xVector<string> GetBlocks(string path);		//gets a list of blocks within this block
  
};




#endif