/**********************************************************
EnviroState C++ source file
Environmental Monitoring System
Last modified by Red Squirrel on Aug-14-2012 10:44:07pm
Filepath: includes/MlConfFile/MlConfVar.cpp
Lines of code: 80

Description: Config file variable.  Type determine by which constructor is used

***********************************************************/




MlConfVar::MlConfVar(string name,string value)
{
    m_name=name;
    Init();
	
	m_type=1;
    
    m_ValStr = new string(value);  
}


MlConfVar::MlConfVar(string name,int value)
{
    m_name=name;
    Init();
	
	m_type=2;
    
    m_ValInt = new int(value);  
}


MlConfVar::MlConfVar(string name,float value)
{
    m_name=name;
    Init();
	
	m_type=3;
    
    m_ValFlo = new float(value);  
}


MlConfVar::~MlConfVar()
{  	
	if(m_ValStr!=NULL)delete m_ValStr;
    if(m_ValInt!=NULL)delete m_ValInt;    
    if(m_ValFlo!=NULL)delete m_ValFlo;
}

void MlConfVar::Init()
{
    m_ValStr=NULL;  
    m_ValInt=NULL;
    m_ValFlo=NULL;    
}


string MlConfVar::Name()
{
  return m_name;
}





string MlConfVar::GetStr()
{
   if(m_ValStr!=NULL)return *m_ValStr;
   
   
   stringstream ss;
   
   if(Type()==2)ss<<GetInt();
   else if(Type()==3)ss<<GetFlo();
   
   m_ValStr = new string(ss.str());     
   
   return *m_ValStr;
}


int MlConfVar::GetInt()
{
   if(m_ValInt!=NULL)return *m_ValInt;
   
   if(Type()==3)
   {
	   m_ValInt= new int((int)*m_ValFlo);
	   return *m_ValInt;
   }

   return 0;
}


float MlConfVar::GetFlo()
{
   if(m_ValFlo!=NULL)return *m_ValFlo;
   

   if(Type()==2)
   {
	   m_ValFlo= new float(*m_ValInt);
	   return *m_ValFlo;
   }   
   
   return 0;
}

int MlConfVar::Type()
{
	return m_type;
}


string MlConfVar::TypeStr()
{
  switch(Type())
  {
     case 1: return "str"; break;
     case 2: return "int"; break;
     case 3: return "flo"; break;
  }
  
  return "";
}
