/**********************************************************
EnviroState C++ source file
Environmental Monitoring System
Last modified by Red Squirrel on Oct-08-2012 06:54:40pm
Filepath: includes/MonitorEntry.cpp
Lines of code: 34

Description: 

***********************************************************/


MonitorEntry::MonitorEntry(AgentCore * core, string name)
{
	m_core = core;
	m_name = name;
	
	m_lastpoll=0;
}


MonitorEntry::~MonitorEntry()
{
	DataEntry * tmpentry=NULL;
	while(m_dataentries.PopFrom(tmpentry,0))
	{	
		delete tmpentry;
	}
}


void MonitorEntry::Log(int val,string txt)
{
	if(m_core!=NULL)m_core->Log(val,"Mon["+m_name+"] " + txt);	
}

bool MonitorEntry::Poll()
{
	if((m_lastpoll+m_pollinterval)>time(NULL))return true;	
	m_lastpoll=time(NULL);
	
	
	//process command:
		
	//TODO: Some kind of safety check to ensure a malicious command cannot execute.  
	//Though This program should not be configured in a way where potential unauthorized users can access it anyway.  
	
	
	Log(4,"Executing command: " + m_source);	
	
	FILE * cmdstream = popen(m_source.c_str(),"r");
	
	char buffer[1024];	
	fgets(buffer, 1024, cmdstream);
	
	pclose(cmdstream);
	
	string output = buffer;	
	
	Log(4,"Command output: " + output);
	
	
	float initvalue = atof(output.c_str());
	
	int finalvalue = int(initvalue*m_multiplier);
	
	
	m_dataentries.Add(new DataEntry(finalvalue,time(NULL)));
	

	return true;
}

