/**********************************************************
EnviroState C++ header file
Environmental Monitoring System
Last modified by Red Squirrel on Oct-07-2012 12:16:28am
Filepath: includes/MonitorEntry.h
Lines of code: 20

Description: Monitor entry (agent mode)

***********************************************************/


#ifndef MonitorEntry_h
#define MonitorEntry_h

class MonitorEntry
{
	friend class AgentCore;
	
	private:
		AgentCore * m_core;		
		
		//remote specified values:
		//------------------------------
		
		string m_name;		
		int m_pollinterval;	
		string m_source;	
		float m_multiplier;
		
		//------------------------------
		//end remote specified values
		
			
		
		xVector<DataEntry*> m_dataentries;
		
		time_t m_lastpoll;
	
	public:
		MonitorEntry(AgentCore * core, string name);
		~MonitorEntry();
		
		void Log(int level,string text);		
		bool Poll();				//polls value (if needed)	
	
};




#endif