/**********************************************************
HVACCTL C++ header file
Home HVAC Control System
Last modified by Ryan Auclair on Feb-15-2012 10:44:13pm
Filepath: includes/uk1104/SerialConnector.h
Lines of code: 24

Description: Generic serial connector class

***********************************************************/


#ifndef SerialConnector_h
#define SerialConnector_h

#include <unistd.h>
#include <fcntl.h>
#include <errno.h>

class SerialConnector
{
	private:
		string m_Path;
		int m_fd;
		bool m_conactive;
		
		void ScreenOutput(string output);				//output to screen if debug is on
	
	public:
		bool DebugMode;
		SerialConnector();
		SerialConnector(string path);
		void SetPath(string path);				//set working path (ex: /dev/tty0)
		bool Open();						//connect
		void Close();					//disconnect
		bool ConActive();					//whether connection has been lost
		string ReadLine(bool waitindef=true,bool nlonly=false);				//get all data until \r\n is hit, or only \n if arg is true
		bool WriteLine(string line, bool nlonly=false);		//writes line of data followed by \r\n or \n if 2nd arg is true

		


};


#endif